Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 1 | #!/bin/sh |
Greg Kroah-Hartman | b244131 | 2017-11-01 15:07:57 +0100 | [diff] [blame] | 2 | # SPDX-License-Identifier: GPL-2.0 |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 3 | # Disassemble the Code: line in Linux oopses |
| 4 | # usage: decodecode < oops.file |
| 5 | # |
| 6 | # options: set env. variable AFLAGS=options to pass options to "as"; |
| 7 | # e.g., to decode an i386 oops on an x86_64 system, use: |
| 8 | # AFLAGS=--32 decodecode < 386.oops |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 9 | # PC=hex - the PC (program counter) the oops points to |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 10 | |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 11 | cleanup() { |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 12 | rm -f $T $T.s $T.o $T.oo $T.aa $T.dis |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 13 | exit 1 |
| 14 | } |
| 15 | |
| 16 | die() { |
| 17 | echo "$@" |
| 18 | exit 1 |
| 19 | } |
| 20 | |
| 21 | trap cleanup EXIT |
| 22 | |
| 23 | T=`mktemp` || die "cannot create temp file" |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 24 | code= |
Andy Shevchenko | 7e68b36 | 2018-01-31 16:14:10 -0800 | [diff] [blame] | 25 | cont= |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 26 | |
| 27 | while read i ; do |
| 28 | |
| 29 | case "$i" in |
| 30 | *Code:*) |
| 31 | code=$i |
Andy Shevchenko | 7e68b36 | 2018-01-31 16:14:10 -0800 | [diff] [blame] | 32 | cont=yes |
| 33 | ;; |
| 34 | *) |
| 35 | [ -n "$cont" ] && { |
| 36 | xdump="$(echo $i | grep '^[[:xdigit:]<>[:space:]]\+$')" |
| 37 | if [ -n "$xdump" ]; then |
| 38 | code="$code $xdump" |
| 39 | else |
| 40 | cont= |
| 41 | fi |
| 42 | } |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 43 | ;; |
| 44 | esac |
| 45 | |
| 46 | done |
| 47 | |
| 48 | if [ -z "$code" ]; then |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 49 | rm $T |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 50 | exit |
| 51 | fi |
| 52 | |
| 53 | echo $code |
| 54 | code=`echo $code | sed -e 's/.*Code: //'` |
| 55 | |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 56 | width=`expr index "$code" ' '` |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 57 | width=$((($width-1)/2)) |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 58 | case $width in |
| 59 | 1) type=byte ;; |
| 60 | 2) type=2byte ;; |
| 61 | 4) type=4byte ;; |
| 62 | esac |
| 63 | |
Marc Zyngier | c5cfb62f | 2018-12-28 00:31:21 -0800 | [diff] [blame] | 64 | if [ -z "$ARCH" ]; then |
| 65 | case `uname -m` in |
| 66 | aarch64*) ARCH=arm64 ;; |
| 67 | arm*) ARCH=arm ;; |
| 68 | esac |
| 69 | fi |
| 70 | |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 71 | # Params: (tmp_file, pc_sub) |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 72 | disas() { |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 73 | t=$1 |
| 74 | pc_sub=$2 |
| 75 | |
| 76 | ${CROSS_COMPILE}as $AFLAGS -o $t.o $t.s > /dev/null 2>&1 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 77 | |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 78 | if [ "$ARCH" = "arm" ]; then |
| 79 | if [ $width -eq 2 ]; then |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 80 | OBJDUMPFLAGS="-M force-thumb" |
| 81 | fi |
| 82 | |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 83 | ${CROSS_COMPILE}strip $t.o |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 84 | fi |
| 85 | |
Will Deacon | be9fa66 | 2018-01-18 16:33:57 -0800 | [diff] [blame] | 86 | if [ "$ARCH" = "arm64" ]; then |
| 87 | if [ $width -eq 4 ]; then |
| 88 | type=inst |
| 89 | fi |
| 90 | |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 91 | ${CROSS_COMPILE}strip $t.o |
Will Deacon | be9fa66 | 2018-01-18 16:33:57 -0800 | [diff] [blame] | 92 | fi |
| 93 | |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 94 | if [ $pc_sub -ne 0 ]; then |
| 95 | if [ $PC ]; then |
| 96 | adj_vma=$(( $PC - $pc_sub )) |
| 97 | OBJDUMPFLAGS="$OBJDUMPFLAGS --adjust-vma=$adj_vma" |
| 98 | fi |
| 99 | fi |
| 100 | |
| 101 | ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $t.o | \ |
| 102 | grep -v "/tmp\|Disassembly\|\.text\|^$" > $t.dis 2>&1 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 103 | } |
| 104 | |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 105 | marker=`expr index "$code" "\<"` |
| 106 | if [ $marker -eq 0 ]; then |
| 107 | marker=`expr index "$code" "\("` |
| 108 | fi |
| 109 | |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 110 | |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 111 | touch $T.oo |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 112 | if [ $marker -ne 0 ]; then |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 113 | # 2 opcode bytes and a single space |
| 114 | pc_sub=$(( $marker / 3 )) |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 115 | echo All code >> $T.oo |
| 116 | echo ======== >> $T.oo |
| 117 | beforemark=`echo "$code"` |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 118 | echo -n " .$type 0x" > $T.s |
| 119 | echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 120 | disas $T $pc_sub |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 121 | cat $T.dis >> $T.oo |
| 122 | rm -f $T.o $T.s $T.dis |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 123 | |
| 124 | # and fix code at-and-after marker |
| 125 | code=`echo "$code" | cut -c$((${marker} + 1))-` |
| 126 | fi |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 127 | echo Code starting with the faulting instruction > $T.aa |
| 128 | echo =========================================== >> $T.aa |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 129 | code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'` |
| 130 | echo -n " .$type 0x" > $T.s |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 131 | echo $code >> $T.s |
Borislav Petkov | d72e720 | 2020-10-13 16:48:14 -0700 | [diff] [blame] | 132 | disas $T 0 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 133 | cat $T.dis >> $T.aa |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 134 | |
Borislav Petkov | 18ff44b | 2013-04-29 15:05:54 -0700 | [diff] [blame] | 135 | # (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3, |
| 136 | # i.e. the title + the "===..=" line (sed is counting from 1, 0 address is |
| 137 | # special) |
| 138 | faultlinenum=$(( $(wc -l $T.oo | cut -d" " -f1) - \ |
| 139 | $(wc -l $T.aa | cut -d" " -f1) + 3)) |
| 140 | |
Borislav Petkov | 2a95e37 | 2012-08-15 13:00:51 +0200 | [diff] [blame] | 141 | faultline=`cat $T.dis | head -1 | cut -d":" -f2-` |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 142 | faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'` |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 143 | |
Ivan Delalande | e08df07 | 2020-05-07 18:35:53 -0700 | [diff] [blame] | 144 | cat $T.oo | sed -e "${faultlinenum}s/^\([^:]*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/" |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 145 | echo |
| 146 | cat $T.aa |
| 147 | cleanup |